﻿using System;
using System.Collections.Generic;
using System.Text;
using System.EnterpriseServices;
using System.Diagnostics;
using Microsoft.Win32;
using System.Runtime.InteropServices;
using ComBaseClass;

[assembly: ApplicationActivation(ActivationOption.Server)]
[assembly: ApplicationAccessControl(false)]
[assembly: ApplicationName("ClassLibraryAsAdmin")]

namespace ClassLibraryAsAdmin
{
    [System.Runtime.InteropServices.Guid("41AC8568-9230-4E63-B7C5-CAAD997EE207")]
    public class AdminCode : ServicedComponent, IAdminCode
    {
        public void SetRegistryValue()
        {
            try
            {
                using (RegistryKey regKey = Registry.LocalMachine.OpenSubKey("SYSTEM", true)) // 관리자 권한 필요
                {
                    regKey.CreateSubKey("Test");
                }
            }
            catch (Exception ex)
            {
                OutputTextLine(ex.ToString());
            }

            if (IntPtr.Size == 4)
            {
                OutputText("x86 ");
            }
            else
            {
                OutputText("x64 ");
            }

            OutputTextLine(".NET Framework: " + Environment.Version.ToString());
        }

        void OutputTextLine(string text)
        {
            OutputText(text + Environment.NewLine);
        }

        void OutputText(string text)
        {
            Console.Write(text);
            System.Diagnostics.Trace.Write(text);
        }

        public void TestMethod()
        {
            OutputTextLine("TestMethod");
        }

        public void TestMethod2()
        {
            OutputTextLine("ComBaseClass: " + typeof(IAdminCode).Assembly.Location);
        }
    }
}
