﻿using System;
using System.Collections.Generic;
using System.Text;

namespace ComBaseClass
{
    public class DelegateClassLib
    {
        static object _comObject;
        public DelegateClassLib()
        {

        }

        public void DoTest()
        {
            Guid guid = new Guid("{41AC8568-9230-4E63-B7C5-CAAD997EE207}");
            Type type = Type.GetTypeFromCLSID(guid);
            ActivateInstance(type);
        }

        private static void ActivateInstance(Type type)
        {
            if (_comObject == null)
            {
                _comObject = Activator.CreateInstance(type);
                Console.WriteLine(_comObject);
            }

            IAdminCode adminCode = _comObject as IAdminCode;
            if (adminCode != null)
            {
                adminCode.SetRegistryValue();
                adminCode.TestMethod();
                adminCode.TestMethod2();
            }
            else
            {
                Console.WriteLine("IAdminCode == null");
                System.Diagnostics.Trace.WriteLine("IAdminCode == null");
            }
        }
    }
}
