REM

FOR /F %%I IN ("%0") DO SET CURRENTDIR=%%~dpI
SET SOLUTIONDIR=%CURRENTDIR%

SET PROJECTPATH=%SOLUTIONDIR%ClassLibraryAsAdmin\ClassLibraryAsAdmin.csproj
SET PROJECTPATH2=%SOLUTIONDIR%ConsoleApplication1\ConsoleApplication1.csproj
SET PROJECTPATH3=%SOLUTIONDIR%ComBaseClass\ComBaseClass.csproj
SET PROJECTPATH4=%SOLUTIONDIR%ComplusInstaller\ComplusInstaller.csproj
SET SRCFILES=ClassLibraryAsAdmin.* ComplusInstaller.* ComBaseClass.* ConsoleApplication1.* net*.bat


REM .NET 2.0 / Debug
msbuild "%PROJECTPATH3%" /t:rebuild /p:Configuration=Debug /p:PlatformTarget=x86;Platform=x86;TargetFrameworkVersion=v3.5
msbuild "%PROJECTPATH4%" /t:rebuild /p:Configuration=Debug /p:PlatformTarget=x86;Platform=x86;TargetFrameworkVersion=v3.5
msbuild "%PROJECTPATH%" /t:rebuild /p:Configuration=Debug /p:PlatformTarget=x86;Platform=x86;TargetFrameworkVersion=v3.5
msbuild "%PROJECTPATH2%" /t:rebuild /p:Configuration=Debug /p:PlatformTarget=x86;Platform=x86;TargetFrameworkVersion=v3.5
robocopy .\bin .\net20\x86 %SRCFILES% /XF *.tlb
robocopy . .\net20\x86 %SRCFILES% /XF *.tlb

msbuild "%PROJECTPATH3%" /t:rebuild /p:Configuration=Debug /p:PlatformTarget=AnyCPU;Platform=AnyCPU;TargetFrameworkVersion=v3.5
msbuild "%PROJECTPATH4%" /t:rebuild /p:Configuration=Debug /p:PlatformTarget=AnyCPU;Platform=AnyCPU;TargetFrameworkVersion=v3.5
msbuild "%PROJECTPATH%" /t:rebuild /p:Configuration=Debug /p:PlatformTarget=AnyCPU;Platform=AnyCPU;TargetFrameworkVersion=v3.5
msbuild "%PROJECTPATH2%" /t:rebuild /p:Configuration=Debug /p:PlatformTarget=AnyCPU;Platform=AnyCPU;TargetFrameworkVersion=v3.5
robocopy .\bin .\net20\AnyCPU %SRCFILES%  /XF *.tlb
robocopy . .\net20\AnyCPU %SRCFILES% /XF *.tlb

msbuild "%PROJECTPATH3%" /t:rebuild /p:Configuration=Debug /p:PlatformTarget=x64;Platform=x64;TargetFrameworkVersion=v3.5
msbuild "%PROJECTPATH4%" /t:rebuild /p:Configuration=Debug /p:PlatformTarget=x64;Platform=x64;TargetFrameworkVersion=v3.5
msbuild "%PROJECTPATH%" /t:rebuild /p:Configuration=Debug /p:PlatformTarget=x64;Platform=x64;TargetFrameworkVersion=v3.5
msbuild "%PROJECTPATH2%" /t:rebuild /p:Configuration=Debug /p:PlatformTarget=x64;Platform=x64;TargetFrameworkVersion=v3.5
robocopy .\bin .\net20\x64 %SRCFILES% /XF *.tlb
robocopy . .\net20\x64 %SRCFILES% /XF *.tlb

REM .NET 4.0 / Debug
msbuild "%PROJECTPATH3%" /t:rebuild /p:Configuration=Debug /p:PlatformTarget=x86;Platform=x86;TargetFrameworkVersion=v4.0
msbuild "%PROJECTPATH4%" /t:rebuild /p:Configuration=Debug /p:PlatformTarget=x86;Platform=x86;TargetFrameworkVersion=v4.0
msbuild "%PROJECTPATH%" /t:rebuild /p:Configuration=Debug /p:PlatformTarget=x86;Platform=x86;TargetFrameworkVersion=v4.0
msbuild "%PROJECTPATH2%" /t:rebuild /p:Configuration=Debug /p:PlatformTarget=x86;Platform=x86;TargetFrameworkVersion=v4.0
robocopy .\bin .\net40\x86 %SRCFILES% /XF *.tlb
robocopy . .\net40\x86 %SRCFILES% /XF *.tlb

msbuild "%PROJECTPATH3%" /t:rebuild /p:Configuration=Debug /p:PlatformTarget=AnyCPU;Platform=AnyCPU;TargetFrameworkVersion=v4.0
msbuild "%PROJECTPATH4%" /t:rebuild /p:Configuration=Debug /p:PlatformTarget=AnyCPU;Platform=AnyCPU;TargetFrameworkVersion=v4.0
msbuild "%PROJECTPATH%" /t:rebuild /p:Configuration=Debug /p:PlatformTarget=AnyCPU;Platform=AnyCPU;TargetFrameworkVersion=v4.0
msbuild "%PROJECTPATH2%" /t:rebuild /p:Configuration=Debug /p:PlatformTarget=AnyCPU;Platform=AnyCPU;TargetFrameworkVersion=v4.0
robocopy .\bin .\net40\AnyCPU %SRCFILES%  /XF *.tlb
robocopy . .\net40\AnyCPU %SRCFILES% /XF *.tlb

msbuild "%PROJECTPATH3%" /t:rebuild /p:Configuration=Debug /p:PlatformTarget=x64;Platform=x64;TargetFrameworkVersion=v4.0
msbuild "%PROJECTPATH4%" /t:rebuild /p:Configuration=Debug /p:PlatformTarget=x64;Platform=x64;TargetFrameworkVersion=v4.0
msbuild "%PROJECTPATH%" /t:rebuild /p:Configuration=Debug /p:PlatformTarget=x64;Platform=x64;TargetFrameworkVersion=v4.0
msbuild "%PROJECTPATH2%" /t:rebuild /p:Configuration=Debug /p:PlatformTarget=x64;Platform=x64;TargetFrameworkVersion=v4.0
robocopy .\bin .\net40\x64 %SRCFILES% /XF *.tlb
robocopy . .\net40\x64 %SRCFILES% /XF *.tlb



cd bin
goto Deploy


"C:\Program Files (x86)\Microsoft SDKs\Windows\v7.0A\Bin\gacutil.exe" /u ClassLibraryAsAdmin
"C:\Program Files (x86)\Microsoft SDKs\Windows\v7.0A\Bin\gacutil.exe" /i ClassLibraryAsAdmin.dll

"C:\Program Files (x86)\Microsoft SDKs\Windows\v7.0A\Bin\NETFX 4.0 Tools\gacutil.exe" /u ClassLibraryAsAdmin
"C:\Program Files (x86)\Microsoft SDKs\Windows\v7.0A\Bin\NETFX 4.0 Tools\gacutil.exe" /i ClassLibraryAsAdmin.dll

:Deploy

robocopy ..\net20 \\192.168.0.26\d$\temp\net20 /S
robocopy ..\net40 \\192.168.0.26\d$\temp\net40 /S


cd..

:EndOfBuild